﻿using UnityEngine;
using System.Collections;

public class ArrowTotemHelper : MonoBehaviour {

	public GameObject arrow;
	public Controller myController;

	void OnValidate(){
		if(!arrow){
			Transform arrowTransform = transform.Find("Arrow");
			if(arrowTransform){
				arrow = arrowTransform.gameObject;
			}
		}
		if(!myController){
			myController = GetComponent<Controller>();
		}
	}

	void FixedUpdate(){
		Collider2D[] colliders = Physics2D.OverlapCircleAll(transform.position, 2, 1 << 9);
		bool found = false;
		foreach(Collider2D collider in colliders){
			if(collider.gameObject == gameObject) continue;
			Controller controller = collider.GetComponent<Controller>();
			if(controller.topTotem) continue;
			if(myController.bottomTotem == controller) continue;
			if(myController.topTotem == controller) continue;
			controller.arrowTotemHelper.arrow.SetActive(true);
			found = true;
		}
		if(!found) arrow.SetActive(false);
	}
}
