﻿using UnityEngine;
using System.Collections;

public class CameraController : MonoBehaviour {


	public GameObject[] totens;
	Vector3 target;

	private Vector3 velocity = Vector3.zero;
	public float smoothTime = 0.15f;

	public bool verticalMaxEnabled = false;
	public float verticalMax = 0f;
	public bool verticalMinEnabled = false;
	public float verticalMin = 0f;
	
	public bool horizontalMaxEnabled = false;
	public float horizontalMax = 0f;
	public bool horizontalMinEnabled = false;
	public float horizontalMin = 0f;

	// Use this for initialization
	void Start () {
	}
	
	// Update is called once per frame
	void LateUpdate() 
	{
		foreach(GameObject go in totens)
		{
			target += go.transform.position;
		}

		target = target/3;


		Vector3 targetPosition = target;
		
		if (verticalMinEnabled && verticalMaxEnabled) {
			targetPosition.y = Mathf.Clamp(target.y, verticalMin, verticalMax);
		} else if (verticalMinEnabled) {
			targetPosition.y = Mathf.Clamp(target.y, verticalMin, target.y);
		} else if (verticalMaxEnabled) {
			targetPosition.y = Mathf.Clamp(target.y, target.y, verticalMax);
		}
		
		if (horizontalMinEnabled && horizontalMaxEnabled) {
			targetPosition.x = Mathf.Clamp(target.x, horizontalMin, horizontalMax);
		} else if (horizontalMinEnabled) {
			targetPosition.x = Mathf.Clamp(target.x, horizontalMin, target.x);
		} else if (horizontalMaxEnabled) {
			targetPosition.x = Mathf.Clamp(target.x, target.x, horizontalMax);
		}
		
		targetPosition.z = transform.position.z;
		
		transform.position = Vector3.SmoothDamp(transform.position, targetPosition, ref velocity, smoothTime);
		target = Vector3.zero;			
	}
}
