﻿using UnityEngine;
using System.Collections;

public class ChocBehavior : MonoBehaviour {

	public int radius = 15;

	public int maxLaserPoints = 5;
	[SerializeField] LineRenderer laser = null;
	[SerializeField] Material mat;
	public GameObject target;
	public float cleanDelay, nextClean;
	public IndioAutoController myOwner;

	void Update(){
		if(!target) return;
		
		laser.SetColors(new Color(Random.Range(0f,1f),Random.Range(0f,1f),Random.Range(0f,1f)),
		                new Color(Random.Range(0f,1f),Random.Range(0f,1f),Random.Range(0f,1f)));
		
		laser.SetPosition(0, this.transform.position);
		
		for(int i = 1; i < maxLaserPoints - 1; i++)
		{
			laser.SetPosition( i, Vector3.Lerp(this.transform.position, target.transform.position , (float)i/maxLaserPoints) + (Vector3)Random.insideUnitCircle );
		}
		
		laser.SetPosition(maxLaserPoints-1, target.transform.position);
		if(Time.time > nextClean){
			Clean();
		}
	}

	public void Attack()
	{
		int counter = 0;
		Collider2D col = Physics2D.OverlapCircle(this.transform.position, radius, 1 << 9);
		if(col){
			target = col.gameObject;
			nextClean = Time.time + cleanDelay;
			TotemStats stats = col.GetComponent<TotemStats>();
			if(stats){
				if(myOwner){
					stats.takeDmg(myOwner.damage[(int)myOwner.myType]);
				} else {
					stats.takeDmg(5);
				}
			}
		}

	}

	public void Clean(){
		target = null;
		for(int i = 0; i < maxLaserPoints; i++)
		{
			laser.SetPosition( i, Vector3.zero );
		}
	}
}
