﻿using UnityEngine;
using System.Collections;
using UnityEngine.UI;

public class FirstBossBehaviour : MonoBehaviour, ITakeDamage {

	public ChocBehavior choc;
	public ZarabatanaBehaviour spear;
	public float speed, turnDelay, nextTurn, meleeDelay, nextMelee, rangedDelay, nextRanged, distanceToKeep;
	public int life;
	public Image hb;
	public GameObject deathPart, mask, finalBoss;

	void Start(){
		nextTurn = Time.time + turnDelay;
		nextMelee = Time.time + meleeDelay;
		nextRanged = Time.time + rangedDelay;
	}
	
	public void takeDmg(int dmg)
	{
		life -= dmg;
	}

	void setBars()
	{
		hb.fillAmount = life/100f;
	}

	public void death()
	{
		GameObject.Instantiate(deathPart, transform.position, Quaternion.identity);
		GameObject.Instantiate(finalBoss, mask.transform.position, Quaternion.identity);
		Destroy(gameObject);
	}

	void Update () 
	{
		
		if(life <= 0)
		{
			death();
		}
		
		setBars();
		
		RaycastHit2D totem = Physics2D.Raycast(transform.position, -transform.right, 35f, 1 << 9);
		if(totem){
			if(totem.distance < distanceToKeep){
				if(Time.time > nextMelee){
					spear.Attack();
					nextMelee = Time.time + meleeDelay;
				}
				if(Time.time > nextRanged){
					choc.Attack();
					nextRanged = Time.time + rangedDelay;
				}
			} else {
				transform.position += speed * -transform.right;
			}
			return;
		}
		
		transform.position += speed * -transform.right;
		
		if(Time.time > nextTurn){
			transform.rotation = Quaternion.Euler(Vector3.up*180f + transform.rotation.eulerAngles);
			nextTurn = Time.time + turnDelay;
		}
	}
}
