﻿using UnityEngine;
using System.Collections;

public class GameManager : MonoBehaviour {

	public static GameManager Singleton = null;

	public bool freezeGlobalMovement = false;
	public float joinAnimationTime = 1f;
	public float joinRotationAmount = 360f;

	public AudioClip menu;
	public AudioClip level1;
	public AudioClip level2;
	public AudioClip level3;
	public AudioClip level4;

	public AudioSource audioSrc;

	public int lastLevelLoaded;

	void Awake(){
		if(!Singleton){
			Singleton = this;
			DontDestroyOnLoad(gameObject);
		} else {
			Destroy(gameObject);
		}
		audioSrc = gameObject.GetComponent<AudioSource>();
	}
	
	void Start(){
		if(lastLevelLoaded != Application.loadedLevel)
		{
			if (Application.loadedLevel == 0)	{
				audioSrc.clip = menu;
			}
			if (Application.loadedLevel == 1)	{
				audioSrc.clip = level1;
			}
			if (Application.loadedLevel == 2)	{
				audioSrc.clip = level2;
			}
			if (Application.loadedLevel == 3)	{
				audioSrc.clip = level3;
			}
			if (Application.loadedLevel == 4)	{
				audioSrc.clip = level4;
			}
			if (Application.loadedLevel == 5)	{
				audioSrc.clip = menu;
			}
			audioSrc.loop = true;
			audioSrc.Play();
		}
		lastLevelLoaded = Application.loadedLevel;
		freezeGlobalMovement = false;
	}
	
	void OnLevelWasLoaded(int level){
		if(lastLevelLoaded != Application.loadedLevel)
		{
			if (Application.loadedLevel == 0)	{
				audioSrc.clip = menu;
			}
			if (Application.loadedLevel == 1)	{
				audioSrc.clip = level1;
			}
			if (Application.loadedLevel == 2)	{
				audioSrc.clip = level2;
			}
			if (Application.loadedLevel == 3)	{
				audioSrc.clip = level3;
			}
			if (Application.loadedLevel == 4)	{
				audioSrc.clip = level4;
			}
			if (Application.loadedLevel == 5)	{
				audioSrc.clip = menu;
			}
			audioSrc.loop = true;
			audioSrc.Play();
		}
		lastLevelLoaded = Application.loadedLevel;
		freezeGlobalMovement = false;
	}

	public void play()
	{
		Application.LoadLevel(1);
	}

	void Update()
	{
		if(Input.GetKeyDown(KeyCode.Escape))
		{
			Application.LoadLevel(0);
		}
	}

	public void Cardapio()
	{
		Application.LoadLevel(0);
	}
}
