﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class IndioAutoController : MonoBehaviour, ITakeDamage {

	public enum IndioType { Melee = 0, Ranged = 1, Voodo = 2};
	public IndioType myType = IndioType.Melee;

	public GameObject[] weapons;
	public float[] distanceToKeep;
	public float[] speed;
	public float[] attackDelay;
	public int[] damage;
	public float nextTurnTime;
	public float nextAttackTime;

	public float dmgFactor = 1;
	public int life = 100;
	public Image hb;

	public Animator anim;

	public GameObject deathPart;

	public AudioSource audioSrc;
	public AudioClip hit;

	void OnValidate(){
		if(!anim){
			anim = GetComponent<Animator>();
		}
	}

	void Start () {
		audioSrc = gameObject.GetComponent<AudioSource>();
		weapons[(int)myType].SetActive(true);
		nextTurnTime = Time.time + 3.5f;
		nextAttackTime = Time.time + attackDelay[(int)myType];
	}


	public void takeDmg(int dmg)
	{
		life -= dmg;
		audioSrc.PlayOneShot(hit);
	}

	void setBars()
	{
		hb.fillAmount = life/10f;
	}

	public void death()
	{
		GameObject.Instantiate(deathPart, transform.position, Quaternion.identity);
		Destroy(gameObject);
	}

	void Update () 
	{

		if(life <= 0)
		{
			death();
		}

		setBars();

		RaycastHit2D totem = Physics2D.Raycast(transform.position, -transform.right, 25f, 1 << 9);
		if(totem){
			if(totem.distance < distanceToKeep[(int)myType]){
				if(Time.time > nextAttackTime){
					weapons[(int)myType].BroadcastMessage("Attack");
					nextAttackTime = Time.time + attackDelay[(int)myType];
				}
			} else {
				transform.position += speed[(int)myType] * -transform.right;
			}
			return;
		}
			
		transform.position += speed[(int)myType] * -transform.right;
		
		if(Time.time > nextTurnTime){
			//transform.localScale = new Vector3(-transform.localScale.x, transform.localScale.y, transform.localScale.z);
			transform.rotation = Quaternion.Euler(Vector3.up*180f + transform.rotation.eulerAngles);
			nextTurnTime = Time.time + 3.5f;
		}
	}
}
