﻿using UnityEngine;
using System.Collections;

public class TotemMatcherMaker : MonoBehaviour {

	public enum Direction { Esquerda = -1, Direita = 1};
	public enum Totems { Aguia = 0, Tartaruga = 1, Cobra = 2};

	public bool randomize = false;
	public Totems[] names;
	public Direction[] directions;
	public GameObject[] markers;

	public GameObject particle;
	public AudioClip clip;

	void OnValidate(){
		ShowMatch();
	}

	void Start(){
		if(randomize){
			Totems[] t = { Totems.Aguia, Totems.Cobra, Totems.Tartaruga };
			Direction[] d = { Direction.Esquerda, Direction.Direita};
			for(int i = 0; i < 3; i++){
				directions[i] = d[Random.Range(0,2)];
				int a = Random.Range(0,3);
				int b = Random.Range(0,3);
				Totems aux = t[b];
				t[b] = t[a];
				t[a] = aux;
			}
			names = t;
		}
		ShowMatch();
	}

	void OnTriggerStay2D(Collider2D collider){
		if(collider.gameObject.layer == 9){
			Controller controller = collider.GetComponent<Controller>();
			if(controller){
				if(!controller.bottomTotem){
					if(checkTotem(controller, 0)){
						GameManager.Singleton.freezeGlobalMovement = true;
						controller.gameObject.AddComponent<TotemRitual>();

						Instantiate(particle, transform.position, Quaternion.identity);
						gameObject.GetComponent<AudioSource>().PlayOneShot(clip);

						Destroy(this);
					}
				}
			}
		}
	}

	bool checkTotem(Controller controller, int idx){
		if(idx == 3) return true;
		if(!controller) return false;
		if(controller.identifier == names[idx]){
			if((int)controller.transform.lossyScale.x == (int)directions[idx]){
				return checkTotem(controller.topTotem, idx+1);
			} else {
				return false;
			}
		} else {
			return false;
		}
	}

	void ShowMatch(){
		int i = -1;
		foreach(Totems name in names){
			markers[(int)name].transform.localPosition = Vector3.up * i * 1.5f;
			markers[(int)name].transform.localScale = new Vector3((float)directions[i+1], 1f, 1f)/2f;
			i++;
		}
	}

}
