﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections;

public class TotemStats : MonoBehaviour, ITakeDamage {

	public float life = 100;
	public float dmgFactor = 1f;
	public float energy = 100;

	public Image hb;
	public Image eb;

	public AudioSource audioSrc;
	public AudioClip dead;

	Controller control;

	// Use this for initialization
	void Start () {
		control = gameObject.GetComponent<Controller>();
		audioSrc = gameObject.GetComponent<AudioSource>();
	}

	public void takeDmg(int dmg)
	{
		Debug.Log (dmg);
		life -= (int)(dmg * dmgFactor);
	}

	public void Death()
	{
		audioSrc.PlayOneShot(dead);

		Application.LoadLevel(Application.loadedLevel);
	}

	void setBars()
	{
		hb.fillAmount = life/100f;
		eb.fillAmount = energy/100f;
	}

	// Update is called once per frame
	void Update () {
		setBars();

		if(control.identifier == TotemMatcherMaker.Totems.Cobra)
		{
			energy += 12*Time.deltaTime;
		}
		else if(control.identifier == TotemMatcherMaker.Totems.Tartaruga)
		{
			life += 1*Time.deltaTime;
			energy += 6*Time.deltaTime;
		}
		else
		{			
			energy += 4*Time.deltaTime;
		}

		if(life <= 0)
		{
			Death();
		}
	}
}
